#define DEBUG_MODE_FULL
#include "script_component.hpp"
#define ALOG(A,B) diag_log [diag_frameNo, diag_tickTime, time, QUOTE(A), B];

dummy = (vehicle player) spawn {
	sleep 1;

	if (isNil "ace_sys_vehicledamage_fnc_survival") then {
		_this addEventhandler ["HandleDamage", {
			// #define DEBUG_MODE_FULL
			#include "script_component.hpp"

			// Usage for e.g hummers; don't blow up in the water... allow to be towed out.
			private["_r", "_pos", "_surfaceIsWater"];
			PARAMS_5(_unit,_selectionName,_damage,_source,_projectile);
			_r = _damage;
			_pos = getPos _unit;
			_surfaceIsWater = surfaceIsWater _pos;

			// TODO: Verify movement speed, and perhaps height; when flying into the water... still damage
			// TODO: Handle drowning of crew.
			if ((_projectile == "") && (_unit == vehicle _source) && _surfaceIsWater) then {
				// TODO: Perhaps verify depth of water somehow...
				_r = 0;
			};

			TRACE_3("Returning damage",_r,_pos,_surfaceIsWater);
			_r;
		}];
	};

	_this addEventhandler ["dammaged",{
		ALOG(damaged,_this);
	}];
	_this addEventhandler ["hit", {
		ALOG(hit,_this);
	}];
	_this addEventhandler ["killed", {
		ALOG(killed,_this);
	}];

	createDialog "ACE_SettingsDialog";

	while {true} do {
		ALOG(currDamage,getDammage _this);
		sleep 1;
	};
};

// Towing ability:
// If player has Rope
// Interaction; Attach Rope to Vehicle 1 (Tow-er)
// Interaction; Attach Rope to Vehicle 2 (Tow-ed)
// Interaction; Detach Rope from Vehicle 1
// Interaction; Detach Rope from Vehicle 2
// TOW Vehicle 2 out by driving Vehicle 1
// FUTURE: Improve animations, physics etc.

// PLACEHOLDERS - Need new models / classes for horizontal rope ;-)
#define ROPE_M "ACE_Rope_TOW_M_5"
#define ROPE_V "ACE_FastRope_50"
#define ROPE_DIST 50

if !(isDedicated) then {
	player addMagazine ROPE_M;
};

if !(isNil "ace_sys_towing_fnc_attachRope") exitWith {};


FUNC(attachRope) = {
	// #define DEBUG_MODE_FULL
	// #include "script_component.hpp"
	private ["_rope", "_exit"];
	PARAMS_2(_target,_type);

	// Abort if vehicle already has a rope attached
	_veh_rope = _target getVariable QUOTE(GVAR(rope));
	_exit = false;
	if !(isNil "_veh_rope") then { if !(isNull _veh_rope) then { _exit = true; } }; // Already has a rope attached
	if (_exit) exitWith {};


	// Fetch existing or create new rope
	_rope = player getVariable QUOTE(GVAR(rope));

	_exit = false;
	if !(isNil "_rope") then { if (isNull _rope) then { _rope = nil } };
	if (isNil "_rope") then {
		if !(ROPE_M in (magazines player)) exitWith { _exit = true };
		player removeMagazine ROPE_M;
		_rope = ROPE_V createVehicle (getPos player);
		player setVariable [QUOTE(GVAR(rope)), _rope];
	};
	if (_exit) exitWith {};


	// Abort if rope is already attached to a vehicle with _type
	_rope_veh = _rope getVariable _type;
	_exit = false;
	if !(isNil "_rope_veh") then { if !(isNull _rope_veh) then { _exit = true; } }; // Already has a rope attached
	if (_exit) exitWith {};


	_rope setVariable [_type, _target, true];


	// Abort if already a vehicle attached, but distance too large
	_a = _rope getVariable QUOTE(GVAR(A));
	_b = _rope getVariable QUOTE(GVAR(B));
	_exit = false;
	if (!(isNil "_a") && !(isNil "_b")) then {
		if (!(isNull _a) && !(isNull _b)) then {
			if (_a distance _b > ROPE_DIST) then {
				_exit = true;
			};
		};
	};
	if (_exit) exitWith {};


	// Attach the rope to the target
	if (_type == QUOTE(GVAR(A))) then {
		_rope attachTo [_target, [0,0,0]];
	} else {
		_target attachTo [_rope, [0,0,0]];
	};
	_target setVariable [QUOTE(GVAR(rope)), _rope, true];
};

// Detach Rope
// Convert Rope into Magazine
FUNC(detachRope) = {
};


// Add InteractionMenu Entry
if !(isDedicated) then {
	[["Car", "Tank", "Air", "Ship"], [ace_sys_interaction_key], -2, ["fnc_menuDef.sqf", "main"]] call CBA_ui_fnc_add;
};
